/* ----------------------------------------------------- */
/* pip_pk.c	( NTHU CS MapleBBS Ver 3.10 )      	 */
/* ----------------------------------------------------- */
/* target : PK Կ                                  */
/* create : 02/02/17                                     */
/* update :   /  /		  			 */
/* author : itoc.bbs@bbs.tnfsh.tn.edu.tw		 */
/* ----------------------------------------------------- */


#include "bbs.h"

#ifdef HAVE_GAME

#include "pip.h"


#if 0

  0. kOiJqlCH PKAM@H 1)WիݵoA
     t@H 2)UDԮѿJe̪ ID Yi}lԡC

  1. PK ɭԥΪȬO ptmp-> ̭AҥHԧ d. ä|ܡC
  2. W[AԪ覡 pip_fight.c hˡC
  3. ԮɤiYɫ~C (i)
  4. Ԯ skillXYZ SSOĥΡC (i)

  5. pip_pk_skill() ]OikAQ諸HAۤvq pip_fight.c ۹LӡC

#endif

/*-------------------------------------------------------*/
/* pip PK cache                                          */
/*-------------------------------------------------------*/


static PCACHE *pshm;
static PTMP *cp;		/* ڪp */
static PTMP *ep;		/* ⪺p */


static void
pip_pkshm_init()
{
  pshm = shm_new(PIPSHM_KEY, sizeof(PCACHE));
}


static int
pip_ptmp_new(pp)
  PTMP *pp;
{
  PTMP *pentp, *ptail;

  /* --------------------------------------------------- */
  /* semaphore : critical section                        */
  /* --------------------------------------------------- */

#ifdef	HAVE_SEM
  sem_lock(BSEM_ENTER);
#endif

  pentp = pshm->pslot;
  ptail = pentp + MAX_PIPPK_USER;

  do
  {
    if (!pentp->inuse)		/* @ӪŦlAcp-> V */
    {
      memcpy(pentp, pp, sizeof(PTMP));
      cp = pentp;

#ifdef	HAVE_SEM
      sem_lock(BSEM_LEAVE);
#endif

      return 1;
    }
  } while (++pentp < ptail);

  /* Thor:iDuserHn@BF */

#ifdef	HAVE_SEM
  sem_lock(BSEM_LEAVE);
#endif

  return 0;
}


static int
pip_ptmp_setup()
{
  PTMP ptmp;

  memset(&ptmp, 0, sizeof(PTMP));

  /* ݩ */
  strcpy(ptmp.name, d.name);
  strcpy(ptmp.userid, cuser.userid);

  ptmp.sex = d.sex;
  ptmp.level = d.level;

  /* ɺ */
  ptmp.hp = d.maxhp;
  ptmp.mp = d.maxmp;
  ptmp.vp = d.maxvp;
  ptmp.sp = d.maxsp;
  ptmp.maxhp = d.maxhp;
  ptmp.maxmp = d.maxmp;
  ptmp.maxvp = d.maxvp;
  ptmp.maxsp = d.maxsp;

  /* UاO */
  ptmp.combat = d.attack + (d.resist >> 2);	/* zq: Mwu׷iBmvj */
  ptmp.magic = d.immune + (d.mskill >> 2);	/* ]ky: MwukN-Utvj */
  ptmp.speed = d.speed + (d.hskill >> 2);	/* ӱޥ: Mwuޯ-@Bޯ-\Bޯ-Ckvj */
  ptmp.spirit = d.brave + (d.etchics >> 2);	/* Oj: Mwuޯ-ߪkBޯ-kBޯ-Mkvj */
  ptmp.charm = d.charm + (d.art >> 2);		/* ʷPyO: MwuybBlvj */
  ptmp.oral = d.speech + (d.manners >> 2);	/* fYae: MwuABʡvj */
  ptmp.cook = d.cook + (d.homework >> 2);	/* i: Mwuޯ-tBkN-vv */

  if (!pip_ptmp_new(&ptmp))
  {
    vmsg("pAPK ȺF");
    return 0;
  }

  return 1;
}


static void
pip_ptmp_free()
{
  if (!cp || !cp->inuse)
    return;

#ifdef  HAVE_SEM
  sem_lock(BSEM_ENTER);
#endif

  cp->inuse = 0;

#ifdef  HAVE_SEM
  sem_lock(BSEM_LEAVE);
#endif
}


static PTMP *
pip_ptmp_get(userid, inuse)
  char *userid;
  int inuse;		/* 1:uWիݵovHӬD  2:uUDԮѡvDԪ̦^ */
{
  PTMP *pentp, *ptail;

  pentp = pshm->pslot;
  ptail = pentp + MAX_PIPPK_USER;
  do
  {
    if (pentp->inuse == inuse && !str_cmp(pentp->userid, userid))
      return pentp;
  } while (++pentp < ptail);

  return NULL;
}


static void
pip_ptmp_show()
{
  int max;
  PTMP *pentp, *ptail;

  clrfromto(7, 16);
  move(10, 5);

  max = 0;
  pentp = pshm->pslot;
  ptail = pentp + MAX_PIPPK_USER;
  do
  {
    if (pentp->inuse)
    {
      max++;
      prints("\033[1;3%dm%-20s\033[m", 2 + pentp->inuse, pentp->userid);

      if (max % 4 == 0)
        move(10 + max % 4, 5);
    }
  } while (++pentp < ptail);

  move(8, 5);
  prints("\033[1;31m԰  \033[33mWիݵo  \033[34mDԪ̵ݦ^\033[m"
    "  ثel̦ \033[1;36m%d/%d\033[m ", max, MAX_PIPPK_USER);
}


/*-------------------------------------------------------*/
/* ԥD禡                                            */
/*-------------------------------------------------------*/


  /*-----------------------------------------------------*/
  /* y                                            */
  /*-----------------------------------------------------*/


static void
pip_pk_turn()	/*  */
{
  cp->done = 1;
  ep->done = 0;
}


  /*-----------------------------------------------------*/
  /* e                                            */
  /*-----------------------------------------------------*/


static void
pip_pk_showfoot()
{
  out_cmd("", COLOR1 " ԰RO " COLOR2 " [1]׷i [2]ޯ [3]yb [4]l [5]A [6] [Q]{            \033[m");
}


static void
pip_pk_showing()
{
  int pic;
  char inbuf1[20], inbuf2[20], inbuf3[20], inbuf4[20];
  
  clear();
  move(0, 0);

  prints("\033[1;41m  " BBSNAME PIPNAME " \033[32m%s\033[37m%-13s                                            \033[m\n", 
    cp->sex == 1 ? "" : (cp->sex == 2 ? "" : "H"), cp->name);

  /* ùWqXڪp */

  sprintf(inbuf1, "%d%s/%d%s", cp->hp > 1000 ? cp->hp / 1000 : cp->hp,
    cp->hp > 1000 ? "K" : "", cp->maxhp > 1000 ? cp->maxhp / 1000 : cp->maxhp,
    cp->maxhp > 1000 ? "K" : "");
  sprintf(inbuf2, "%d%s/%d%s", cp->mp > 1000 ? cp->mp / 1000 : cp->mp,
    cp->mp > 1000 ? "K" : "", cp->maxmp > 1000 ? cp->maxmp / 1000 : cp->maxmp,
    cp->maxmp > 1000 ? "K" : "");
  sprintf(inbuf3, "%d%s/%d%s", cp->vp > 1000 ? cp->vp / 1000 : cp->vp,
    cp->vp > 1000 ? "K" : "", cp->maxvp > 1000 ? cp->maxvp / 1000 : cp->maxvp,
    cp->maxvp > 1000 ? "K" : "");
  sprintf(inbuf4, "%d%s/%d%s", cp->sp > 1000 ? cp->sp / 1000 : cp->sp,
    cp->sp > 1000 ? "K" : "", cp->maxsp > 1000 ? cp->maxsp / 1000 : cp->maxsp,
    cp->maxsp > 1000 ? "K" : "");

  outs("\033[1;31mzwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww{\033[m\n");
  prints("\033[1;31mx\033[33m  R:\033[37m%-12s\033[33mk  O:\033[37m%-12s\033[33mʤO:\033[37m%-12s\033[33m  O:\033[37m%-12s\033[31mx\033[m\n", inbuf1, inbuf2, inbuf3, inbuf4);
  prints("\033[1;31mx\033[33m  :\033[37m%-12d\033[33m]  k:\033[37m%-12d\033[33m  :\033[37m%-12d\033[33mZ  N:\033[37m%-12d\033[31mx\033[m\n", cp->combat, cp->magic, cp->speed, cp->spirit);
  prints("\033[1;31mx\033[33my  O:\033[37m%-12d\033[33mf  ~:\033[37m%-12d\033[33mi  :\033[37m%-12d\033[33m  :\033[37m%-12d\033[31mx\033[m\n", cp->charm, cp->oral, cp->cook, cp->level);
  outs("\033[1;31m|wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww}\033[m");

  /* ù 7~16 C qXǪ */
  pic = 101 + 100 * (rand() % 5) + rand() % 3;    /* 101~501 102~502 103~503 Q@ */
  show_badman_pic(pic);

  /* ùUqX誺p */

  sprintf(inbuf1, "%d%s/%d%s", ep->hp > 1000 ? ep->hp / 1000 : ep->hp,
    ep->hp > 1000 ? "K" : "", ep->maxhp > 1000 ? ep->maxhp / 1000 : ep->maxhp,
    ep->maxhp > 1000 ? "K" : "");
  sprintf(inbuf2, "%d%s/%d%s", ep->mp > 1000 ? ep->mp / 1000 : ep->mp,
    ep->mp > 1000 ? "K" : "", ep->maxmp > 1000 ? ep->maxmp / 1000 : ep->maxmp,
    ep->maxmp > 1000 ? "K" : "");
  sprintf(inbuf3, "%d%s/%d%s", ep->vp > 1000 ? ep->vp / 1000 : ep->vp,
    ep->vp > 1000 ? "K" : "", ep->maxvp > 1000 ? ep->maxvp / 1000 : ep->maxvp,
    ep->maxvp > 1000 ? "K" : "");
  sprintf(inbuf4, "%d%s/%d%s", ep->sp > 1000 ? ep->sp / 1000 : ep->sp,
    ep->sp > 1000 ? "K" : "", ep->maxsp > 1000 ? ep->maxsp / 1000 : ep->maxsp,
    ep->maxsp > 1000 ? "K" : "");

  move(18, 0);
  outs("\033[1;34mzwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww{\033[m\n");
  prints("\033[1;34mx\033[32mm  W:\033[37m%-12s\033[32m  :\033[37m%-12s\033[32m  O:\033[37m%-12s\033[32m  :\033[37m%-12d\033[34mx\033[m\n", ep->name, ep->userid, ep->sex == 1 ? "" : (ep->sex == 2 ? "" : "H"), ep->level);
  prints("\033[1;34mx\033[32m  R:\033[37m%-12s\033[32mk  O:\033[37m%-12s\033[32mʤO:\033[37m%-12s\033[32m  O:\033[37m%-12s\033[34mx\033[m\n", inbuf1, inbuf2, inbuf3, inbuf4);
  outs("\033[1;34m|wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww}\033[m\n");

  pip_pk_showfoot(); 
}


static void
pip_pk_ending()
{
  clrfromto(7, 16);
  move(8, 0);

  if (cp->hp > 0)
  {
    outs("           \033[1;31mzwwwwwwwwwwwwwwwwwwwwww{\033[m\n");
    prints("           \033[1;31mx \033[37mZNj|p\033[33m%-13s                \033[31mx\033[m\n", cp->name);
    prints("           \033[1;31mx \033[37mѤFjl\033[32m%-13s              \033[31mx\033[m\n", ep->name);
    outs("           \033[1;31mx \033[37miMg糣WɤF                     \033[31mx\033[m\n");
    outs("           \033[1;31m|wwwwwwwwwwwwwwwwwwwwww}\033[m");
    vmsg("zѤF@ӱjwå");
    d.exp += ep->level;
  }
  else
  {
    outs("           \033[1;31mzwwwwwwwwwwwwwwwwwwwwww{\033[m\n");
    prints("           \033[1;31mx \033[37mZNj|p\033[33m%-13s                \033[31mx\033[m\n", cp->name);
    prints("           \033[1;31mx \033[37mQ\033[32m%-13s\033[37m⥴oy            \033[31mx\033[m\n", ep->name);
    outs("           \033[1;31mx \033[37mMw^annAm                         \033[31mx\033[m\n");
    outs("           \033[1;31m|wwwwwwwwwwwwwwwwwwwwww}\033[m");
    vmsg("QѪzߤ۷OD");
    d.exp -= cp->level;
  }
}


  /*-----------------------------------------------------*/
  /* ʨ禡                                            */
  /*-----------------------------------------------------*/


static void
pip_pk_combat()		/* ׷i */
{
  int injure;

  injure = cp->combat - (ep->combat >> 2);
  if (injure > 0)
  {
    ep->hp -= injure;
    show_fight_pic(1);
    vmsg("zyF誺ˮ`");
  }
  else
  {
    show_fight_pic(2);
    vmsg("zb貴²Oko");
  }
  pip_pk_turn();  
}


static void 
pip_pk_skill()		/* ޯ: Z\/]k */
{
  /* itoc.020217: iog pip_fight.c ̭تFA쪺Hۤv۵ۧ :p */

  /* ޯणIAĪGt(uLb) */

  int ch, class;
  int injure[5] = {125, 200, 300, 450, 750};

  out_cmd(COLOR1 " Z\\ " COLOR2 " [1]@ [2]\\ [3]ߪk [4]k [5]Ck [6]Mk [7]t [Q]    \033[m",
    COLOR1 " kN " COLOR2 " [A]v [B]pt [C]Bt [D]t [E]gt [F]t [G]S [Q]    \033[m");

  for (;;)
  {
    ch = vkey();

    if (ch == 'q')
    {
      pip_pk_showfoot();
      return;
    }

    else if (ch == '1')		/* @ */
    {
      class = rand() % 10;
      if (class == 0)		/* 10% vϼuAiAק */
      {
        ep->hp -= cp->speed >> 3;
        vmsg("⪺ϼu^LW");
      }
      else if (class <= 2)	/* 20% vϹ誫zûCAiAק */
      {
        ep->combat = ep->combat * 4 / 5;
        vmsg("誺FAݨӵuɶ|_");
      }
      else			/* 70% v򳣨S */
      {
        vmsg("zĨmI");
        break;
      }
      pip_pk_showfoot();
      return;
    }

    else if (ch == '2')		/* \ */
    {
      class = cp->speed >> 9;
      if (class > 4)
        class = 4;

      cp->vp += injure[class];	/*  vp ]ɥ injure[] */      
      if (cp->vp > cp->maxvp)
        cp->vp = cp->maxvp;

      vmsg("믫AǳƦA");
      break;
    }

    else if (ch == '3')		/* ߪk */
    {
      class = cp->spirit >> 9;
      if (class > 4)
        class = 4;

      cp->sp += injure[class];	/*  sp ]ɥ injure[] */      
      if (cp->sp > cp->maxsp)
        cp->sp = cp->maxsp;

      vmsg("ORKAǳƦA");
      break;
    }

    else if (ch == '4')		/* k */
    {
      class = cp->spirit >> 9;
      if (class > 4)
        class = 4;

      ep->hp -= injure[class] * (75 + rand() % 50) / 100;
      vmsg("OxWAĤO@");
      break;
    }

    else if (ch == '5')		/* Ck */
    {
      class = cp->speed >> 9;
      if (class > 4)
        class = 4;

      ep->hp -= injure[class] * (50 + rand() % 100) / 100;
      vmsg("ּCٶó¡AC");
      break;
    }

    else if (ch == '6')		/* Mk */
    {
      class = cp->spirit >> 9;
      if (class > 4)
        class = 4;

      ep->hp -= injure[class] * (30 + rand() % 140) / 100;
      vmsg("OxWAĤO@");
      break;
    }

    else if (ch == '7')		/* t */
    {
      class = cp->cook >> 9;
      if (class > 4)
        class = 4;

      ep->hp -= injure[class] * (80 + rand() % 40) / 100;
      vmsg("zaUFrġA⤣`NNYFUh");
      break;
    }

    else if (ch == 'a')		/* v */
    {
      class = cp->cook >> 10;	/*  hp e */
      if (class > 4)
        class = 4;

      cp->hp += injure[class];	/*  hp ]ɥ injure[] */      
      if (cp->hp > cp->maxhp)
        cp->hp = cp->maxhp;

      vmsg("RqHAAץXo");
      break;
    }

    else if (ch >= 'b' && ch <= 'f')		/* UtkN */
    {
      char buf[64];
      char name[5][3] = {"p", "B", "", "g", ""};

      class = cp->magic >> 9;
      if (class > 4)
        class = 4;

      ep->hp -= injure[class] * (50 + rand() % 100) / 100;
      sprintf(buf, "zIiF%stkNA¤OQ", name[ch - 'b']);
      vmsg(buf);
      break;
    }

    else if (ch == 'g')		/* S */
    {
      class = cp->magic >> 9;
      if (class > 4)
        class = 4;

      cp->mp += injure[class];	/*  mp ]ɥ injure[] */      
      if (cp->mp > cp->maxmp)
        cp->mp = cp->maxmp;

      vmsg("qRA]OA{");
      break;
    }
  }

  pip_pk_turn();
}


static void
pip_pk_charm()		/* yb:  hp */
{
  int class;
  char buf[80];
  char name[5][9] = {"ZҫUl", "ⱡg", "p", "s", ""};
  int injure[5] = {250, 400, 600, 900, 1500};
  int needhp[5] = {350, 600, 900, 1500, 3200};

  class = cp->charm >> 8;	/* ۹HUT̡AһݪeCNiHIijjybNAӪO hp */
  if (class > 4)
    class = 4;

  if (cp->hp >= needhp[class])
  {
    cp->hp -= needhp[class];
    ep->hp -= injure[class] * (75 + rand() % 50) / 100;
    sprintf(buf, "@s%sbzϤUAR", name[class]);
    vmsg(buf);
    pip_pk_turn();
  }
  else
  {
    vmsg("zOˤfAٷQyb");
    pip_pk_showfoot();  
  }
}


static void
pip_pk_summon()		/* l:  mp */
{
  int class;
  char buf[80];
  char name[5][9] = {"vܩi", "Y", "r", "js", ""};
  int injure[5] = {250, 400, 600, 900, 1500};
  int needmp[5] = {350, 600, 900, 1500, 3200};

  class = cp->charm >> 9;
  if (class > 4)
    class = 4;

  if (cp->mp >= needmp[class])
  {
    cp->mp -= needmp[class];
    ep->hp -= injure[class] * (75 + rand() % 50) / 100;
    sprintf(buf, "zlX%sAaF@", name[class]);
    vmsg(buf);
    pip_pk_turn();
  }
  else
  {
    vmsg("zPhΡA]lꤣX");
    pip_pk_showfoot();  
  }
}


static void
pip_pk_convince()	/* A:  vp */
{
  int class;
  char buf[80];
  char name[5][9] = {"ǤH", "u\\Y", "JWH", "Fs", "Ѥjt"};
  int injure[5] = {250, 400, 600, 900, 1500};
  int needvp[5] = {350, 600, 900, 1500, 3200};

  class = cp->oral >> 9;
  if (class > 4)
    class = 4;

  if (cp->vp >= needvp[class])
  {
    cp->vp -= needvp[class];
    ep->hp -= injure[class] * (75 + rand() % 50) / 100;
    sprintf(buf, "z\\aA%sӧUz@uO", name[class]);
    vmsg(buf);
    pip_pk_turn();
  }
  else
  {
    vmsg("ǨӤ@}nGQAڡAA@ʦ~a");
    pip_pk_showfoot();  
  }
}


static void
pip_pk_incite()		/* :  sp */
{
  int class;
  char buf[80];
  char name[5][9] = {"ǩ", "C|", "a", "Qs", "KѨ"};
  int injure[5] = {250, 400, 600, 900, 1500};
  int needsp[5] = {350, 600, 900, 1500, 3200};

  class = cp->oral >> 9;
  if (class > 4)
    class = 4;

  if (cp->sp >= needsp[class])
  {
    cp->sp -= needsp[class];
    ep->hp -= injure[class] * (40 + rand() % 120) / 100;	/* ܲʸeT̬ */
    sprintf(buf, "zia%sӱڸsӹIĤH", name[class]);
    vmsg(buf);
    pip_pk_turn();
  }
  else
  {
    vmsg("HҰʡAzpeѤF");
    pip_pk_showfoot();  
  }
}


static void
pip_pk_man()		/* ڤUO */
{
  /* qX԰De */
  pip_pk_showing();

  while (!cp->done)
  {
    switch (vkey())
    {
    case '1':		/* ׷i */
      pip_pk_combat();
      break;

    case '2':		/* ޯ: Z\/]k */
      pip_pk_skill();
      break;

    case '3':		/* yb */
      pip_pk_charm();
      break;

    case '4':		/* l */
      pip_pk_summon();
      break;

    case '5':		/* A */
      pip_pk_convince();
      break;

    case '6':		/*  */
      pip_pk_incite(); 
      break;

    case 'q':		/* { */
      cp->hp = 0;
      pip_pk_turn();
      break;
    }
  }
}


static void
pip_pk_wait()		/* ݹUO */
{
  int fd;
  struct timeval tv = {1, 100};

  /* qX԰De */
  pip_pk_showing();

  outz("ݹ誺 Q){");
  refresh();

  while (!ep->done)
  {
    fd = 1;
    if (select(1, (fd_set *) &fd, NULL, NULL, &tv) > 0)
    {
      if (vkey() == 'q')
      {
	cp->done = 1;	/* GHj */
	ep->done = 1;      
	cp->hp = 0;	/* } */
	break;
      }
    }
  }
}


/*-------------------------------------------------------*/
/* ԥD                                            */
/*-------------------------------------------------------*/


int 
pip_pk_menu()
{
  int ch;
  char userid[IDLEN + 1];
  struct timeval tv = {1, 100};

  /* itoc.020327: ZjDOApGԨ@bA䤤@H_uFA
     t~@H|iJjAu Q } */

  if (d.hp <= 0)
    return XEASY;

  pip_pkshm_init();

  pip_ptmp_show();

  ch = ians(b_lines, 0, " p 1)Wիݵo 2)UDԮ [Q]} ");
  if (ch == '1')
  {
    /* ]w cp-> */
    if (!pip_ptmp_setup())
      return XEASY;

    cp->inuse = 1;

    outz("ԬDԤ Q)}");
    refresh();
    do
    {
      ch = 1;
      if (select(1, (fd_set *) &ch, NULL, NULL, &tv) > 0)
      {
	if (vkey() == 'q')
	{
	  pip_ptmp_free();
	  return XEASY;
	}
      }
    } while (!*cp->mateid);

    if (!(ep = pip_ptmp_get(cp->mateid, 2)))
    {
      pip_ptmp_free();
      return XEASY;
    }
    cp->done = 0;	/* QDԪ̥ʡADԪ̴N|qL */
    cp->inuse = -1;	/* 賣iJ԰ */
    ep->inuse = -1;
  }
  else if (ch == '2')
  {
    /* Mw PK ԹH ep-> */
    if (!vget(b_lines, 0, msg_uid, userid, IDLEN + 1, DOECHO) || 
      !str_cmp(cuser.userid, userid) ||
      !(ep = pip_ptmp_get(userid, 1)))
    {
      return XEASY;
    }

    /* ]w cp-> */
    if (!pip_ptmp_setup())
      return XEASY;

    strcpy(cp->mateid, userid);
    strcpy(ep->mateid, cuser.userid);
    cp->done = 1;	/* DԪ̫ʡAN|DʳqQDԪ */
    cp->inuse = 2;
  }
  else
  {
    return XEASY;
  }

  ch = d.tired;

  for (;;)		/*  */
  {  
    pip_pk_man();
    if (ep->hp <= 0 || cp->hp <= 0)
      break;          

    pip_pk_wait();
    if (cp->hp <= 0 || ep->hp <= 0)
      break;
  }

  /* GP_ */
  pip_pk_ending();

  pip_ptmp_free();

  d.tired = ch;		/* HK PK Ӥ[APK Ӧ] tired LF */
  return 0;
}
#endif	/* HAVE_GAME */
